=== debian/changelog ===
frugen (2.0+git20240917.25293b1-1) unstable; urgency=medium

  * New upstream version 2.0+git20240917.25293b1 (closes: #1086610)

 -- Shengqi Chen <harry-chen@outlook.com>  Sat, 02 Nov 2024 17:22:26 +0800
