=== debian/control ===
Source: frugen
Section: utils
Priority: optional
Standards-Version: 4.7.0
Maintainer: Shengqi Chen <harry-chen@outlook.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 doxygen,
 graphviz,
 help2man,
 libjson-c-dev,
Homepage: https://codeberg.org/IPMITool/frugen
Vcs-Git: https://salsa.debian.org/harry/frugen.git
Vcs-Browser: https://salsa.debian.org/harry/frugen
Rules-Requires-Root: no

Package: libfru2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: frugen
Description: Universal IPMI FRU Information generator / editor library
 frugen is a universal, full-featured IPMI FRU Information generator /
 editor library and command line tool, written in full compliance with
 IPMI FRU Information Storage Definition v1.0, rev. 1.3.
 .
 This package contains libfru2 shared library.

Package: libfru-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libfru2 (= ${binary:Version})
Description: Universal IPMI FRU Information generator / editor library (development files)
 frugen is a universal, full-featured IPMI FRU Information generator /
 editor library and command line tool, written in full compliance with
 IPMI FRU Information Storage Definition v1.0, rev. 1.3.
 .
 This package contains development files for libfru.

Package: frugen
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libfru2 (= ${binary:Version})
Description: Universal IPMI FRU Information generator / editor
 frugen is a universal, full-featured IPMI FRU Information generator /
 editor library and command line tool, written in full compliance with
 IPMI FRU Information Storage Definition v1.0, rev. 1.3.
 .
 This package contains the frugen utility.
