=== debian/changelog ===
frugen (2.1-3) unstable; urgency=medium

  * Do source-only upload to enable migration.
  * libfru-dev: move header files back to /usr/include (this does not
    affect Multi-Arch: same).

 -- Shengqi Chen <harry@debian.org>  Fri, 28 Feb 2025 12:08:05 +0800

frugen (2.1-2) unstable; urgency=medium

  * Move documentation from libfru-dev to new binary package libfru-doc.
  * d/control:
    + bump std-ver to 4.7.1 (no changes required).
    + mark libfru-dev as Multi-Arch: same.
    + mark libfru-doc as Multi-Arch: foreign.
  * Install headers into path with host-triple to comply with Multi-Arch
    attribute.

 -- Shengqi Chen <harry@debian.org>  Wed, 26 Feb 2025 14:00:02 +0800

frugen (2.1-1) unstable; urgency=medium

  * New upstream version 2.1
  * d/patch: refresh existing patches, remove -Werror for gcc 14
  * d/control: add pkgconf in B-D, use my d.o email address
  * Refresh symbol control file for libfru2

 -- Shengqi Chen <harry@debian.org>  Wed, 12 Feb 2025 16:47:35 +0800
