=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: frugen
 Section: utils
 Priority: optional
-Standards-Version: 4.7.0
-Maintainer: Shengqi Chen <harry-chen@outlook.com>
+Standards-Version: 4.7.1
+Maintainer: Shengqi Chen <harry@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
@@ -10,6 +10,7 @@
  graphviz,
  help2man,
  libjson-c-dev,
+ pkgconf,
 Homepage: https://codeberg.org/IPMITool/frugen
 Vcs-Git: https://salsa.debian.org/harry/frugen.git
 Vcs-Browser: https://salsa.debian.org/harry/frugen
@@ -31,13 +32,27 @@
 Package: libfru-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}, libfru2 (= ${binary:Version})
+Recommends: libfru-doc (= ${binary:Version})
 Description: Universal IPMI FRU Information generator / editor library (development files)
  frugen is a universal, full-featured IPMI FRU Information generator /
  editor library and command line tool, written in full compliance with
  IPMI FRU Information Storage Definition v1.0, rev. 1.3.
  .
  This package contains development files for libfru.
+
+Package: libfru-doc
+Section: doc
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Description: Universal IPMI FRU Information generator / editor library (documentation)
+ frugen is a universal, full-featured IPMI FRU Information generator /
+ editor library and command line tool, written in full compliance with
+ IPMI FRU Information Storage Definition v1.0, rev. 1.3.
+ .
+ This package contains documentation for libfru.
 
 Package: frugen
 Architecture: any
