=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

TARGET_LIBDIR = /usr/lib/$(DEB_HOST_MULTIARCH)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIB=ON -DCMAKE_INSTALL_LIBDIR=$(TARGET_LIBDIR) -DBUILD_VERSION=$(DEB_VERSION_UPSTREAM)

override_dh_auto_build:
	dh_auto_build -- all docs

execute_after_dh_auto_install:
	LD_LIBRARY_PATH=debian/tmp$(TARGET_LIBDIR) help2man --version-string=$(DEB_VERSION_UPSTREAM) --name="Universal, full-featured IPMI FRU Information generator" -N -o frugen.1 debian/tmp/usr/bin/frugen

override_dh_auto_test:
	# No test suite
