=== debian/watch ===
version=4
  opts="mode=git, pgpmode=none" \
  https://codeberg.org/IPMITool/frugen.git \
  refs/tags/v([\d\.]+) debian uupdate
