=== debian/changelog ===
frugen (3.0-1) unstable; urgency=medium

  * New upstream version 3.0.
    + Bump SONAME to libfru3.
    + d/patches: refresh existing patches.
    + Rewrite symbol definition files for libfru3.
    + d/copyright: update according to upstream source.
  * d/rules: switch cmake backend to ninja.
  * d/rules: temporarily disable some gcc warning to make it compile.
  * d/control: bump std-ver to 4.7.2 (no changes required).
  * d/tests: temporarily disable json test in smoke-test.

 -- Shengqi Chen <harry@debian.org>  Thu, 14 Aug 2025 23:54:01 +0800
