## frugen 3.0%2Bgit20251027.6643c5c

=== debian/changelog ===
frugen (3.0+git20251027.6643c5c-1) unstable; urgency=medium

  * d/watch: switch to version 5.
  * New upstream version 3.0+git20251027.6643c5c (closes: #1117979).
  * d/symbols: remove useless symbols from libfru3.
  * d/patches: refresh existing patches.

 -- Shengqi Chen <harry@debian.org>  Tue, 28 Oct 2025 09:40:02 +0800
