## frugen 3.0+git20251027.6643c5c

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
 cmake_minimum_required(VERSION 3.5)
+
+include(GenerateExportHeader)
 
 # To make frugen 32-bit, set BINARY_32BIT or use an external toolchain file
 option(BINARY_32BIT "compile 32bit version" OFF)
@@ -23,7 +25,7 @@
 	OUTPUT_STRIP_TRAILING_WHITESPACE
 )
 if(NOT res EQUAL 0)
-	set(gitver "v2.0-dirty-orphan")
+	set(gitver "v3.0-dirty-orphan")
 endif()
 
 string(REPLACE "v" "" gitver "${gitver}")
@@ -39,12 +41,18 @@
 option(JSON_STATIC "link json-c library statically" OFF)
 option(DEBUG_OUTPUT "show extra debug output" OFF)
 
-set(CMAKE_C_FLAGS_RELEASE "-Os")
-set(CMAKE_C_FLAGS_DEBUG "-g3 -O0")
+message(STATUS "Compiler is ${CMAKE_C_COMPILER_ID} ${CMAKE_C_COMPILER_VERSION}")
 if(MSVC)
 	# warning level 4
 	add_compile_options(/W4)
 else(MSVC)
+	set(CMAKE_C_FLAGS_RELEASE "-Os")
+	set(CMAKE_C_FLAGS_DEBUG "-g3 -O0")
+	# Enable static analyzer for gcc 13+
+	# It still may produce some falso positives, but it's quite decent already.
+	if(CMAKE_C_COMPILER_ID STREQUAL "GNU" AND CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL "13.0")
+		add_compile_options(-fanalyzer)
+	endif()
 	# additional warnings
 	add_compile_options(
 		-Wall
@@ -70,8 +78,9 @@
 include("doxygen.cmake")
 set(DOXY_PROJECT_NUMBER "${gitver}")
 set(DOXY_OUTPUT_LANGUAGE "English")
-set(DOXY_INPUT "${PROJECT_SOURCE_DIR} ${PROJECT_SOURCE_DIR}/build")
-set(DOXY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/docs")
+set(DOXY_INPUT "${PROJECT_SOURCE_DIR} ${CMAKE_BINARY_DIR}")
+set(DOXY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/docs")
+set(DOXY_STRIP_FROM_PATH "${CMAKE_BINARY_DIR}")
 add_documentation(docs Doxyfile)
 
 # build libfru
@@ -106,6 +115,9 @@
 
 if(BUILD_SHARED_LIB)
 	add_library(fru-shared SHARED ${libfru_SOURCES} ${libfru_HEADERS})
+	set_target_properties(fru-shared PROPERTIES C_VISIBILITY_PRESET hidden)
+	generate_export_header(fru-shared BASE_NAME fru)
+
 	add_library(frugen::fru-shared ALIAS fru-shared)
 	target_include_directories(fru-shared PUBLIC
 		$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
@@ -114,23 +126,29 @@
 	set_target_properties(fru-shared PROPERTIES OUTPUT_NAME fru CLEAN_DIRECT_OUTPUT 1)
 	set_target_properties(fru-shared PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})
 	set_target_properties(fru-shared PROPERTIES PUBLIC_HEADER "${libfru_PUBLIC_HEADERS}")
+	set_target_properties(fru-shared PROPERTIES C_STANDARD 23)
 	list(APPEND LIB_TARGETS "fru-shared")
 endif(BUILD_SHARED_LIB)
 if(BINARY_STATIC OR NOT BUILD_SHARED_LIB)
 	add_library(fru-static STATIC ${libfru_SOURCES} ${libfru_HEADERS})
 	add_library(frugen::fru-static ALIAS fru-static)
+	set_target_properties(fru-static PROPERTIES C_VISIBILITY_PRESET hidden)
+	generate_export_header(fru-static BASE_NAME fru)
 	target_include_directories(fru-static PUBLIC
 		$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
 		$<INSTALL_INTERFACE:include>
 	)
 	set_target_properties(fru-static PROPERTIES OUTPUT_NAME fru CLEAN_DIRECT_OUTPUT 1)
 	set_target_properties(fru-static PROPERTIES PUBLIC_HEADER "${CMAKE_CURRENT_BINARY_DIR}/fru.h")
+	set_target_properties(fru-static PROPERTIES C_STANDARD 23)
 	list(APPEND LIB_TARGETS "fru-static")
 endif(BINARY_STATIC OR NOT BUILD_SHARED_LIB)
 
 # target for frugen
 set(frugen_SOURCES frugen.c)
 add_executable(frugen ${frugen_SOURCES})
+
+set_target_properties(frugen PROPERTIES C_VISIBILITY_PRESET default)
 
 if(ENABLE_JSON)
 	find_package(PkgConfig)
@@ -170,11 +188,15 @@
 
 list(APPEND ALL_TARGETS ${LIB_TARGETS} "frugen")
 
-if (CMAKE_BUILD_TYPE STREQUAL "Debug")
-	set_target_properties(frugen PROPERTIES LINK_FLAGS "-Wl,--gc-sections,--print-gc-sections")
-else()
-	set_target_properties(frugen PROPERTIES LINK_FLAGS "-Wl,--gc-sections")
+if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
+	if (CMAKE_BUILD_TYPE STREQUAL "Debug")
+		set_target_properties(frugen PROPERTIES LINK_FLAGS "-Wl,--gc-sections,--print-gc-sections")
+	else()
+		set_target_properties(frugen PROPERTIES LINK_FLAGS "-Wl,--gc-sections")
+	endif()
 endif()
+
+set_target_properties(frugen PROPERTIES C_STANDARD 23)
 
 if(BINARY_STATIC)
 	target_link_libraries(frugen -static)
