=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: frugen
 Section: utils
 Priority: optional
-Standards-Version: 4.7.1
+Standards-Version: 4.7.2
 Maintainer: Shengqi Chen <harry@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
@@ -10,13 +10,14 @@
  graphviz,
  help2man,
  libjson-c-dev,
+ ninja-build,
  pkgconf,
 Homepage: https://codeberg.org/IPMITool/frugen
 Vcs-Git: https://salsa.debian.org/harry/frugen.git
 Vcs-Browser: https://salsa.debian.org/harry/frugen
 Rules-Requires-Root: no
 
-Package: libfru2
+Package: libfru3
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -27,13 +28,13 @@
  editor library and command line tool, written in full compliance with
  IPMI FRU Information Storage Definition v1.0, rev. 1.3.
  .
- This package contains libfru2 shared library.
+ This package contains libfru shared library.
 
 Package: libfru-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libfru2 (= ${binary:Version})
+Depends: ${misc:Depends}, libfru3 (= ${binary:Version})
 Recommends: libfru-doc (= ${binary:Version})
 Description: Universal IPMI FRU Information generator / editor library (development files)
  frugen is a universal, full-featured IPMI FRU Information generator /
@@ -56,7 +57,7 @@
 
 Package: frugen
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, libfru2 (= ${binary:Version})
+Depends: ${misc:Depends}, ${shlibs:Depends}, libfru3 (= ${binary:Version})
 Description: Universal IPMI FRU Information generator / editor
  frugen is a universal, full-featured IPMI FRU Information generator /
  editor library and command line tool, written in full compliance with
