=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,7 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_CFLAGS_MAINT_APPEND = -Wno-stringop-truncation
 
 include /usr/share/dpkg/buildflags.mk
 include /usr/share/dpkg/pkg-info.mk
@@ -8,7 +9,7 @@
 TARGET_LIBDIR = /usr/lib/$(DEB_HOST_MULTIARCH)
 
 %:
-	dh $@ --buildsystem=cmake
+	dh $@ --buildsystem=cmake+ninja
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DBUILD_SHARED_LIB=ON -DCMAKE_INSTALL_LIBDIR=$(TARGET_LIBDIR) -DBUILD_VERSION=$(DEB_VERSION_UPSTREAM)
