=== debian/watch ===
Version: 5
Source: https://codeberg.org/IPMITool/frugen.git
Mode: git
PgpMode: none
Matching-Pattern: refs/tags/v([\d\.]+)
